devices/urls.py
from django.urls import path
import devices.views

app_name = "devices"

urlpatterns = [
    path("", devices.views.Index.as_view(), name="index"),
    path("accept/<str:device>", devices.views.AcceptDevice.as_view(), name="accept"),
    path("reject/<str:device>", devices.views.RejectDevice.as_view(), name="reject"),
    path("devicelist/", devices.views.DeviceList.as_view(), name="devicelist"),
   #path("devicedetails/", devices.views.DeviceDetails.as_view(), name="devicedetails"),
    path("devicedetails/<int:device_id>/", devices.views.DeviceDetails123.as_view(), name="devicedetails"),
    path('snapshot-device/<str:device>/', devices.views.DeviceSnapshotSave.as_view(), name='snapshot-device'),

    path(
        "<str:device>/network/<str:network>",
        devices.views.NetworkDevice.as_view(),
        name="network",
    ),
]

nsp/urls.py
import api.views
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path

from drf_yasg import openapi
from drf_yasg.views import get_schema_view

from rest_framework import routers, permissions
from rest_framework.authtoken import views
from django.template.defaulttags import register


@register.filter
def get_item(dictionary, key):
    return dictionary.get(key)


openapi_info = openapi.Info(
    title="NSP",
    default_version="0.1.0",
    description="Network Science Platform",
    contact=openapi.Contact(email="keith.birdsall@aicloud.guru"),
    license=openapi.License(name="MIT License"),
)

schema_view = get_schema_view(
    openapi_info,
    public=True,
    permission_classes=[permissions.AllowAny],
)


class OptionalSlashRouter(routers.DefaultRouter):
    def __init__(self):
        super().__init__()
        self.trailing_slash = "/?"


api_router = OptionalSlashRouter()

api_router.register(r"admin/users", api.views.UserViewSet)
api_router.register(r"admin/groups", api.views.GroupViewSet)

api_router.register(r"tenants", api.views.TenantViewSet)
api_router.register(r"epgs", api.views.EndpointGroupViewSet)
api_router.register(r"jobs", api.views.JobViewSet)
api_router.register(r"executions", api.views.JobExecutionViewSet)
api_router.register(r"results", api.views.JobResultViewSet)
api_router.register(r"devices", api.views.DeviceViewSet)
api_router.register(r"dashboards", api.views.DashboardViewSet)
api_router.register(r"networks", api.views.BaseNetworkViewSet)
api_router.register(r"vrfs", api.views.VrfViewSet)
api_router.register(r"l3vnis", api.views.L3VniViewSet)
api_router.register(r"vlans", api.views.VlanViewSet)
api_router.register(r"interfaces", api.views.InterfaceViewSet)
#api_router.register(r"snapshots", api.views.SnapshotViewSet)

urlpatterns = [
    path("admin/", admin.site.urls),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
    path("api-token-auth/", views.obtain_auth_token),
    path("api/", include(api_router.urls)),
    # path("api/epgs/", api.views.EndpointGroupList.as_view()),
    # path("api/epgs/<int:id>/", api.views.EndpointGroupDetail.as_view()),
    path("login/", include("login.urls")),
    path("networks/", include("networks.urls")),
    path("jobs/", include("jobs.urls")),
    path("dashboards/", include("dashboards.urls")),
    path("settings/", include("settings.urls")),
    path("devices/", include("devices.urls")),
    re_path(
        r"^api/swagger(?P<format>\.json|\.yaml)$",
        schema_view.without_ui(cache_timeout=0),
        name="schema-json",
    ),
    re_path(
        r"^api/swagger/$",
        schema_view.with_ui("swagger", cache_timeout=0),
        name="schema-swagger-ui",
    ),
    re_path(
        r"^api/redoc/$",
        schema_view.with_ui("redoc", cache_timeout=0),
        name="schema-redoc",
    ),
    path("", include("devices.urls")),
    path("", include("django_prometheus.urls")),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

devices/models.py
from django.db import models
from django_prometheus.models import ExportModelOperationsMixin
from django.db.models import JSONField


class BaseNetworkDevice(ExportModelOperationsMixin("device"), models.Model):
    id = models.AutoField(primary_key=True)
    name = models.CharField(max_length=50)
    network = models.CharField(max_length=50, blank=True)
    salt_key_status = models.CharField(max_length=20, blank=True)
    serial = models.CharField(max_length=100)


class DeviceSnapshot(models.Model):
    id = models.AutoField(primary_key=True)
    created_at = models.DateTimeField(auto_now_add=True)
    devicename = models.CharField(max_length=50, blank=True)
    config = JSONField(default={"run": "run"})

devices/views.py
import clients.salt
import devices.models
import utils.helpers
from asgiref.sync import sync_to_async
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.views import generic
from django.http import HttpResponse
import json
from .models import BaseNetworkDevice



class Index(generic.View):
    async def get(self, request):
        if not await utils.helpers.is_authenticated(request):
            return HttpResponseRedirect("/login/")
        return render(
            request,
            "devices/index.html",
            {
                "devices": await sync_to_async(list)(
                    devices.models.BaseNetworkDevice.objects.all().order_by("name")
                )
            },
        )


class Devices(generic.View):
    async def get(self, request, name=None):
        results = []
        objects = await sync_to_async(list)(
            devices.models.BaseNetworkDevice.objects.filter(name=name)[:1000]
        )
        for object in objects:
            object = object.__dict__
            results.append(object)
        return render(
            request,
            "devices/index.html",
            {"devices": results},
        )


class AcceptDevice(generic.View):
    async def get(self, request, device=None):
        try:
            device_obj = await sync_to_async(
                devices.models.BaseNetworkDevice.objects.get
            )(name=device)
            device_obj.salt_key_status = "accepted"
            await sync_to_async(device_obj.save)()
        except devices.models.BaseNetworkDevice.DoesNotExist:
            raise
        await clients.salt.AsyncClient().accept_key(device)
        return HttpResponseRedirect("/")


class RejectDevice(generic.View):
    async def get(self, request, device=None):
        try:
            device_obj = await sync_to_async(
                devices.models.BaseNetworkDevice.objects.get
            )(name=device)
            device_obj.salt_key_status = "rejected"
            await sync_to_async(device_obj.save)()
        except devices.models.BaseNetworkDevice.DoesNotExist:
            raise
        await clients.salt.AsyncClient().reject_key(device)
        return HttpResponseRedirect("/")


class NetworkDevice(generic.View):
    async def get(self, request, device=None, network=None):
        try:
            device_obj = await sync_to_async(
                devices.models.BaseNetworkDevice.objects.get
            )(name=device)
            device_obj.network = network
            await sync_to_async(device_obj.save)()
        except devices.models.BaseNetworkDevice.DoesNotExist:
            raise
        return HttpResponseRedirect("/")


class DeviceSnapshotSave(generic.View):
    def get(self, request, device):
        try:
            salt_function = clients.salt.Client()
            snap_data = salt_function.snap_config(device)
            start_index = snap_data.find('{')
            json_data = snap_data[start_index:]
            json_data = json.loads(json_data)
            json_data = json.dumps(json_data, indent=4)
            print(json_data)
            if snap_data is None:
                return HttpResponse('SaltStack command failed')
            snap_config_results = devices.models.DeviceSnapshot(
                devicename=device,
                config=json_data,
            )
            snap_config_results.save()
        except devices.models.BaseNetworkDevice.DoesNotExist:
            raise
        return HttpResponse('File copied and saved successfully!')


class DeviceDetails(generic.View):
    def get(self, request):
        hostname = 'leaf01zzz'
        return render(
            request,
            "devices/device_details.html",
            {"hostname": hostname},
        )


class DeviceDetails123(generic.View):
    def get(self, request, device_id):
        # Use the 'device_id' parameter to retrieve the device information
        device = devices.models.BaseNetworkDevice.objects.get(pk=device_id)
        hostname = device.name  # Use the appropriate field here

        return render(
            request,
            "devices/device_details.html",
            {"hostname": hostname},
        )



class DeviceList(generic.View):
    def get(sel, request):
        devices = BaseNetworkDevice.objects.exclude(salt_key_status="unaccepted")
        return render(request, 'devices/device_list.html', {'devices': devices})

devices/templates/devices/device_details.html
{% extends 'base.html' %}
{% load static %}

{% block sidebar %}
{% endblock sidebar %}

{% block content-title %}
<div class="row">
  <nav title="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item" aria-current="page"><a href="{% url 'devices:devicedetails' %}">DeviceDetails</a></li>
    </ol>
  </nav>
</div>
{% endblock content-title %}

{% block content %}
<p>{{hostname}}</p>
<p> xxxxxxxxx </p>
<p>{{hostname}}</p>

{% endblock content %}

{% block javascript %}
<script src="{% static 'devices/js/devices.js' %}"></script>
{% endblock javascript %}

devices/templates/devices/device_list.html
{% extends 'base.html' %}
{% load static %}

{% block sidebar %}
{% endblock sidebar %}

{% block content-title %}
<div class="row">
  <nav title="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item" aria-current="page"><a href="{% url 'devices:devicelist' %}">Device List</a></li>
    </ol>
  </nav>
</div>
{% endblock content-title %}

{% block content %}
<table id="devices" class="table table-light table-striped table-borderless table-hover table-editable">
      <thead>
        <tr>
            <th>ID</th>
            <th>Name</th>
            <th>Network</th>
            <th>Salt Key Status</th>
            <th>Serial</th>
        </tr>
        </thead>
      <tbody>
        {% for device in devices %}
        <tr>
            <th>{{ device.id }}</th>
            <th scope="row" class="center-row">
                <span class="name-field">{{ device.name }}</span>
                <a href="{% url 'devices:devicedetails' %}" class="btn btn-outline-success copy-button">Details</a>
                <!--<a href="{% url 'devices:devicedetails' %}" class="btn btn-outline-success copy-button">Details</a>-->
            </th>
            <th>{{ device.network }}</th>
            <th>{{ device.salt_key_status }}</th>
            <th>{{ device.serial }}</th>
        </tr>
        {% endfor %}
    </tbody>
</table>

{% endblock content %}

{% block javascript %}
<script src="{% static 'devices/js/devices.js' %}"></script>
{% endblock javascript %}

devices/templates/devices/index.html
{% extends 'base.html' %}
{% load static %}

{% block sidebar %}
{% endblock sidebar %}

{% block content-title %}
<div class="row">
  <nav title="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item" aria-current="page"><a href="{% url 'devices:index' %}">Devices</a></li>
    </ol>
  </nav>
</div>
{% endblock content-title %}

{% block content %}
<div class="row">
  <div class="col-lg-12">
    <table id="devices" class="table table-light table-striped table-borderless table-hover table-editable">
      <thead>
        <tr>
          <th scope="col">name</th>
          <th scope="col">network</th>
          <th scope="col">salt_key_status</th>
          <th scope="col">serial</th>
        </tr>
      </thead>
      <tbody>
        {% for device in devices %}
        <tr>
          <th scope="row" class="center-row">
            <span class="name-field">{{device.name}}</span>

              <button class="btn btn-outline-success copy-button" data-device-id="{{ device.name }}"
                      data-url="{% url 'devices:snapshot-device' device=device.name %}">Snap Config</button>
              <div class="tooltip">Click to Snap Config</div>
          </th>
          <th scope="row"><span contenteditable="true" class="network-field">{{device.network}}</span></th>
          {% if device.salt_key_status == "unaccepted" %}
          <th scope="row"><span class="text-info">{{device.salt_key_status}}</span>
            <button class="btn btn-outline-success float-end" data-bs-toggle="modal" data-bs-target="#saltKeyModal"
              data-salt-key-title="Accept Key" data-salt-key-body='Are you sure you want to accept: '
              data-device-id="{{device.name}}" data-salt-key-button="Accept"
              data-salt-key-url="{% url 'devices:accept' device=device.name %}"><i
                class="fa-solid fa-check"></i></button>
            <button class="btn btn-outline-danger float-end" data-bs-toggle="modal" data-bs-target="#saltKeyModal"
              data-salt-key-title="Reject Key" data-salt-key-body='Are you sure you want to reject: '
              data-device-id="{{device.name}}" data-salt-key-button="Reject"
              data-salt-key-url="{% url 'devices:reject' device=device.name %}"><i
                class="fa-solid fa-xmark"></i></button>
          </th>
          {% elif device.salt_key_status == "accepted" %}
          <th scope="row" class="text-success">{{device.salt_key_status}}</th>
          {% elif device.salt_key_status == "denied" %}
          <th scope="row" class="text-warning">{{device.salt_key_status}}</th>
          {% elif device.salt_key_status == "rejected" %}
          <th scope="row" class="text-danger">{{device.salt_key_status}}</th>
          {% else %}
          <th scope="row">{{device.salt_key_status}}</th>
          {% endif %}
          <th scope="row">{{device.serial}}</th>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</div>

<div class="modal fade" id="saltKeyModal" tabindex="-1" aria-labelledby="saltKeyModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="saltKeyModalLabel"></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <span id="modal-body"></span>
        <br><span id="deviceId" name="deviceId" value=""></span>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
        <a id="results" href="">
          <button type="button" class="btn btn-primary" id="salt-key-button"></button></a>
      </div>
    </div>
  </div>
</div>

{% endblock content %}

{% block javascript %}
<script src="{% static 'devices/js/devices.js' %}"></script>
{% endblock javascript %}